/**
 * \brief Instance header file for ATSAME54P20A
 *
 * Copyright (c) 2021 Microchip Technology Inc. and its subsidiaries.
 *
 * Subject to your compliance with these terms, you may use Microchip software and any derivatives
 * exclusively with Microchip products. It is your responsibility to comply with third party license
 * terms applicable to your use of third party software (including open source software) that may
 * accompany Microchip software.
 *
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY,
 * APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL OR CONSEQUENTIAL
 * LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF
 * MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
 * ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT
 * EXCEED THE AMOUNT OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 */

/* file generated from device description version 2021-04-16T09:25:23Z */
#ifndef _SAME54_ADC0_INSTANCE_
#define _SAME54_ADC0_INSTANCE_


/* ========== Instance Parameter definitions for ADC0 peripheral ========== */
#define ADC0_BANDGAP                             _UL_(27)   /* MUXPOS value to select BANDGAP */
#define ADC0_CTAT                                _UL_(29)   /* MUXPOS value to select CTAT */
#define ADC0_DMAC_ID_RESRDY                      _UL_(68)   /* index of DMA RESRDY trigger */
#define ADC0_DMAC_ID_SEQ                         _UL_(69)   /* Index of DMA SEQ trigger */
#define ADC0_EXTCHANNEL_MSB                      _UL_(15)   /* Number of external channels */
#define ADC0_GCLK_ID                             _UL_(40)   /* index of Generic Clock */
#define ADC0_MASTER_SLAVE_MODE                   _UL_(1)    /* ADC Master/Slave Mode */
#define ADC0_OPAMP2                              _UL_(0)    /* MUXPOS value to select OPAMP2 */
#define ADC0_OPAMP01                             _UL_(0)    /* MUXPOS value to select OPAMP01 */
#define ADC0_PTAT                                _UL_(28)   /* MUXPOS value to select PTAT */
#define ADC0_TOUCH_IMPLEMENTED                   _UL_(1)    /* TOUCH implemented or not */
#define ADC0_TOUCH_LINES_NUM                     _UL_(32)   /* Number of touch lines */
#define ADC0_INSTANCE_ID                         _UL_(103)  /* Instance index for ADC0 */

#endif /* _SAME54_ADC0_INSTANCE_ */
